<?php
/**
 * Created by PhpStorm.
 * User: phillipesilva
 * Date: 16/01/2015
 * Time: 10:36
 */

namespace Folha\Logic\ControlePonto;

use Folha\Entities\GpeParamorg;

class MarcacaoPonto
{
    const ALTERACAO_EXCLUSAO     = 'ALT_EXC';         /*Alteração e Exclusão do registro são permitidas*/
    const NOT_ALTERACAO_EXCLUSAO = 'NOT_ALT_EXC';     /*Alteração e Exclusão do registro não são permitidas*/
    const NOT_EXC_LIMITA_ALT     = 'NOT_EXC_LIM_ALT'; /*Exclusão do registro permitida; Alteração de apenas alguns campos*/

    public static function getPermissaoAltExcMarcacao($nrColetor, $nrOrg)
    {
        $paramOrg = GpeParamorg::findOneByNrorg($nrOrg);

        $coletorMarcDig = $paramOrg->getNrcoletormarcdigit();
        $coletorMarcAut = $paramOrg->getNrcoletormarcautom();
        $coletorMarcGerSist = $paramOrg->getNrcoletormarcgersist();
        $coletorMarcViraDia = $paramOrg->getNrcoletormarcviradia();

        if($nrColetor == $coletorMarcAut || $nrColetor == $coletorMarcViraDia || $nrColetor == $coletorMarcDig) {
            $permissao = self::ALTERACAO_EXCLUSAO;
        } else if($nrColetor == $coletorMarcGerSist) {
            $permissao = self::NOT_ALTERACAO_EXCLUSAO;
        } else {
            $permissao = self::NOT_EXC_LIMITA_ALT;
        }

        return $permissao;
    }

    public static function getColetorMarcDigitada($nrOrg)
    {
        $paramOrg = GpeParamorg::findOneByNrorg($nrOrg);

        if(is_object($paramOrg)) {
            return $paramOrg->getNrcoletormarcdigit();
        }

        return '';
    }
} 