function Est65000_ControleContagemEstoque_Controller(General, restEngine, ScreenService, ZhFilterPreferences, templateManager) {

    this.initialize = function(widget) {
        var rowsToSet = {};
        var dataAtual = moment();
        var mes = dataAtual.format("M");
        var ano = dataAtual.format("YYYY");
        
        widget.dataSourceFilter[0].value = new Date(ano, mes, 0).getDateBr();
        widget.dataSourceFilter[1].value = new Date(ano, mes-1, 1).getDateBr();
        
        widget.getField("NMFILIAL").filterProperties.readOnly = true;
        widget.getField("NMFILIAL").filterProperties.validations = {};
        rowsToSet.DTPESQUISA = dataAtual.format('MM/YYYY');
        rowsToSet.TCDFILIAL = "T";
        rowsToSet.IMPORTACAO = "A";
        rowsToSet.CONTAGEM = "A";
        rowsToSet.ENCERRADO = "A";
        rowsToSet.NOOUDIFERENTE = "A";
        
        ZhFilterPreferences.setOriginalFilter(widget.id, rowsToSet);
        ZhFilterPreferences.openFilterWidget(widget, rowsToSet);
        
    };
    
    this.onChangeData = function(args){
        if(args.owner.field.value()){
            var mes = args.owner.field.value().split("/")[0];
            var ano = args.owner.field.value().split("/")[1];
            var widget = templateManager.container.getWidget("tabela");
            widget.dataSourceFilter[0].value = new Date(ano, mes, 0).getDateBr();
            widget.dataSourceFilter[1].value = new Date(ano, mes-1, 1).getDateBr();
        }
         
    };
    
    this.onChangeDia = function(args){
        let dia = args.owner.field.value();
        if(dia){
            let data = dia + args.owner.field.widget.getField("DTPESQUISA").value();
            if(moment(data, "DDMMYYYY")._d == "Invalid Date"){
                args.owner.field.clearValue();
            }
        }
    };
    
    /*  Função para bloquear os fields filhos ligados a um field pai.
        Caso desbloqueiaComValor = true o field filho será habilitado 
        se o field pai possuir valor. No caso de valueDesbloqueia != null
        o valor para desbloquear o filho deve ser igual ao valor de valueDesbloqueia.
        
        @param field field 
    */
    
    this.alteraReadOnlyFilhos = function(field) {
        let widget = field.widget;
        field.filhos.forEach((filho) => {
            var desbloqueiaComValor = (filho.desbloqueiaComValor) ? filho.desbloqueiaComValor : true;
            var valueDesbloqueia    = (filho.valueDesbloqueia)    ? filho.valueDesbloqueia    : null;
            var isRequired          = (filho.isRequired)          ? filho.isRequired          : false;
            
            let filhoField = widget.getField(filho.name);
            
            
            if(valueDesbloqueia == null) {
                filhoField.readOnly =  ((field.value() == "") == desbloqueiaComValor);
                if(((field.value() == "") == desbloqueiaComValor)) widget.currentRow[filho.name] = "";
                if(filhoField.filhos) this.alteraReadOnlyFilhos(filhoField, true);
                widget.getField(filho.name).reload();
            }
            else {
                var habilita = (field.value() == valueDesbloqueia);
                if(habilita) {
                    if(filhoField.readOnly) {
                        if(filho.clearFields) {
                            filho.clearFields.forEach((clearField) => {
                                widget.currentRow[clearField] = "";
                            });
                        }
                        widget.currentRow[filho.name] = "";
                    }
                    
                    filhoField.readOnly = false;
                    
                    if(isRequired) {
                        if(filhoField.validations) {
                            filhoField.validations.required = true;
                        }
                        else {
                            filhoField.validations = {required : true};
                        }
                    }
                }
                else {
                    var filhoOutData = filhoField.outData;
                    for(var fieldOut in filhoOutData) {
                        widget.currentRow[fieldOut] = "";
                    } 
                    widget.currentRow[filho.name] = "";
                    filhoField.readOnly = true;
                    if(isRequired) {
                        if(filhoField.validations) {
                            if(filhoField.validations.required) delete filhoField.validations.required;
                        }
                    }
                }
                if(filhoField.filhos) this.alteraReadOnlyFilhos(filhoField, true);
                widget.getField(filho.name).reload();
            }
        });
    };

    /*
        Percorre uma widget procurando por fields com a propiedade "filhos".
        Para os fields com a propiedade fields a função adiciona o evento 
        de alteraReadOnlyFilhos.
        
        @param widget widget
        @param boolean filter
    */
    
    this.blockFieldsFilhosAndSetEvents = function(widget, filter = true) {
        let fields = widget.fields;
        fields.forEach((field) => {
            if(field.filhos) {
                field.events.push(
                    {
                        "name": "FieldOnChange",
                        "code": "Est65000_ControleContagemEstoque_Controller.alteraReadOnlyFilhos(args.owner.field)"
                    }
                );
                
                field.filhos.forEach((filho) => {
                    if(filter) {
                        if(!widget.getField(filho.name).filterProperties) 
                            widget.getField(filho.name).filterProperties = {};
                        
                        widget.getField(filho.name).filterProperties.readOnly = false; 
                    }
                    else  widget.getField(filho.name).readOnly = false; 
                });
            }
        });
        
        this.initialize(widget);
        
    };
    
    this.filterAfterApply = function(args) {
        args.e.preventDefault();
        var widget = args.owner;
        let dia, nooudif;
        
        widget.dataSourceFilter.forEach( filter => {
            
            if(filter.name == "NODIA" ||  filter.name == "EXCETODIA"){
                filter.value = null;
            } else if(filter.name == "DIA"){
                dia = filter;
            } else if(filter.name == "NOOUDIFERENTE"){
                nooudif = filter;
            }
        });
        
        if(dia && dia.value && nooudif.value != 'A'){
            widget.dataSourceFilter.push(
                {
                    name: nooudif.value == "N" ? "NODIA" : "EXCETODIA",
                    operator: nooudif.value == "N" ? "=" : "<>",
                    value: dia.value
                }
            );
        }
        
        widget.dataSourceFilter = widget.dataSourceFilter.filter((f) => {
            if( (f.name == "IMPORTACAO" || f.name == "CONTAGEM" || f.name == "ENCERRADO") && (f.value == "A" || !f.value)){
                return false;
            } else if(f.name == "TCDFILIAL" || f.name == "NOOUDIFERENTE" || f.name == "DIA"){
                return false;
            } else if( (f.name == "NODIA" || f.name == "EXCETODIA") && !f.value ){
                return false;
            } else if(f.name == "DTPESQUISA"){
                return false;
            } else{
                return true;
            }
        });
        widget.reload();
    };
    
    this.openSwipeAjustes = function(widget){
        let widgetAjustes = widget.container.getWidget('gridAjustes');
        
        let dtInicial = widget.dataSourceFilter.filter(row => row.name == 'P_DTINICIAL')[0].value;
        let dtFinal   = widget.dataSourceFilter.filter(row => row.name == 'P_DTFINAL')[0].value;
        widgetAjustes.dataSourceFilter = [
                {
                    "name": "IDTPLANCTO",
                    "operator": "=",
                    "value": "1"
                },
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": widget.currentRow.CDFILIAL
                },
                {
                    "name": "DTLANCESTQ",
                    "operator": "BETWEEN",
                    "value": [dtInicial, dtFinal]
                }
            ];
            
		 ScreenService.openSwipe(widgetAjustes).then(()=>{
		     widgetAjustes.reload();
		 });

    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('Est65000_ControleContagemEstoque_Controller', Est65000_ControleContagemEstoque_Controller);
});