function retiradaDeEstoque() {
	const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
	const z = new ZeedhiAPIConstructor(browser, protractor);
	const Helper = require('teknisa-helper');
	const geral = new Helper.geral();
	const j = require('../../json/leitorJson.po.js');
	const protractorHelper = require('protractor-helper');

	var EC = protractor.ExpectedConditions;

	this.abrir =  function(){
		geral.abrir(['Estoque', 'Retirada de Estoque']);
		this.fazerFiltro();
	};

	this.fazerFiltro = function(){
		browser.wait(EC.elementToBeClickable($('#footer #footer div.zh-footer-right li a .zh-footer-title-sprit'))).then(function(aplicarFiltro){
			if(aplicarFiltro){
				//geral.clickLimparCampoData('.zh-field-DTINICIAL');
				//geral.clickLimparCampoData('.zh-field-DTFINAL');
				geral.clickAndFillField('DTINICIAL', geral.geraDataDoDia());
				geral.clickAndFillField('DTFINAL', geral.geraDataDoDia());
				geral.clickAplicarFiltro();
			}
		});
	};

	this.validaValorEmEdicao = function() {
		var filial = element.all(by.css('#NMFILIAL .value')).getText().then(function(texto){
			expect(texto).toContain(j.getValor('nomeFilialComControle'));
		});
	};

	this.inserirAbaRetiradaDeEstoque = function(){
		browser.wait(EC.elementToBeClickable($('.zh-field-DTLANCESTQ #close-x'))).then(function(inseri){
			if(inseri){
				geral.clickLimparCampoData('.zh-field-DTLANCESTQ');
				geral.clickAndFillField('DTLANCESTQ', geral.geraDataDoDia());
				geral.searchAndClickGridField('NMSETOR', j.getValor('setor'));
				geral.searchAndClickGridField('NMTIPORETI', j.getValor('tipoRetirada'));
				geral.clickAndFllField('DSLANCESTQ', j.getValor('textoDescricao'));
				z.component.footer.clickRightActionByLabel('Adicionar Produtos');
			}
		});
		this.inserirAbaProdutos();
		geral.clickVoltar();
		geral.waitGridVisibility(j.getValor('gridPrincipal'));
	};

	this.inserirAbaProdutos = function(){
		browser.wait(EC.elementToBeClickable($('.zh-footer-center .action-icon'))).then(function(inseri){
			if(inseri){
				geral.clickAdicionar();
				geral.searchAndClickGridField('NMPRODUTO', j.getValor('nomeProduto'));
			}
		});
		this.inserirAbaComplementaresDoProduto();
		geral.clickAndFllField('QTTOTLANCTO', '2');
		z.component.footer.clickRightActionByLabel('Adicionar');
		geral.esperarLoading();
		this.verificaProdutoInserido();
		geral.clickSalvar();
		geral.esperarLoading();
	};

	this.verificaProdutoInserido = function(){
		browser.wait(EC.elementToBeClickable($('#grid-176086331525036521342777 .body-content .tr'))).then(function(validacao){
			if(validacao){
				expect(geral.gridHasText(j.getValor('gridProduto'), '00.A2.200.000.00', 0, )).toBe(j.getValor('codigoProduto'));
				expect(geral.gridHasText(j.getValor('gridProduto'), 'Acai Desidratado em Cubos (7x7x10mm) KG', 1, )).toBe(j.getValor('nomeProduto'));
			}
		});
	};

	this.inserirAbaComplementaresDoProduto = function(){
		browser.wait(EC.elementToBeClickable($('#NRLOTEESTQ .zh-icon-search #search'))).then(function(pronto){
			if(pronto){
				protractorHelper.click(element(by.css('#NRLOTEESTQ .zh-icon-search')));
				geral.searchTextOnFloating(j.getValor('loteProduto'));
				geral.clickGrid('NRLOTEESTQ', j.getValor('loteProduto'), '9000');
				geral.clickConfirmar();
			}
		});
	};
}

module.exports = new retiradaDeEstoque();